(function () {
  /*! matchMedia() polyfill - Test a CSS media type/query in JS. Authors & copyright (c) 2012: Scott Jehl, Paul Irish, Nicholas Zakas. Dual MIT/BSD license */
  window.matchMedia = window.matchMedia || (function (doc) {
    var bool,
    docElem = doc.documentElement,
    refNode = docElem.firstElementChild || docElem.firstChild,
    // fakeBody required for <FF4 when executed in <head>
    fakeBody = doc.createElement("body"),
    div = doc.createElement("div");

    div.id = "mq-test-1";
    div.style.cssText = "position:absolute;top:-100em";
    fakeBody.style.background = "none";
    fakeBody.appendChild(div);

    return function (q) {

      div.innerHTML = "&shy;<style media=\"" + q + "\"> #mq-test-1 { width: 42px; }</style>";

      docElem.insertBefore(fakeBody, refNode);
      bool = div.offsetWidth === 42;
      docElem.removeChild(fakeBody);

      return {
        matches: bool,
        media: q
      };

    };

  }(window.document));
})();

jqmModule.config(['$provide', function ($provide) {
  $provide.decorator('$sniffer', ['$delegate', '$window', '$document', function ($sniffer, $window, $document) {
    var fakeBody = angular.element("<body>");
    angular.element($window.document.body).prepend(fakeBody);

    $sniffer.cssTransform3d = transform3dTest();

    android2Transitions();

    fakeBody.remove();

    return $sniffer;

    function media(q) {
      return window.matchMedia(q).matches;
    }

    // This is a copy of jquery mobile 1.3.1 detection for transform3dTest
    function transform3dTest() {
      var mqProp = "transform-3d",
      vendors = [ "Webkit", "Moz", "O" ],
      // Because the `translate3d` test below throws false positives in Android:
      ret = media("(-" + vendors.join("-" + mqProp + "),(-") + "-" + mqProp + "),(" + mqProp + ")");

      if (ret) {
        return !!ret;
      }

      var el = $window.document.createElement("div"),
      transforms = {
        // We’re omitting Opera for the time being; MS uses unprefixed.
        'MozTransform': '-moz-transform',
        'transform': 'transform'
      };

      fakeBody.append(el);

      for (var t in transforms) {
        if (el.style[ t ] !== undefined) {
          el.style[ t ] = 'translate3d( 100px, 1px, 1px )';
          ret = window.getComputedStyle(el).getPropertyValue(transforms[ t ]);
        }
      }
      return ( !!ret && ret !== "none" );
    }

    //Fix android 2 not reading transitions correct.
    //https://github.com/angular/angular.js/pull/3086
    //https://github.com/angular-widgets/angular-jqm/issues/89
    function android2Transitions() {
      if (!$sniffer.transitions || !$sniffer.animations) {
        $sniffer.transitions = angular.isString($document[0].body.style.webkitTransition);
        $sniffer.animations = angular.isString($document[0].body.style.webkitAnimation);
        if ($sniffer.animations || $sniffer.transitions) {
          $sniffer.vendorPrefix = 'webkit';
          $sniffer.cssTransform3d = true;
        }
      }
    }

  }]);
}]);
